#! /usr/bin/awk -f

BEGIN {
  split("", stored);
  cnt = 0;
  state = "generic";
}

function flush_stored(   i)
{
  for (i = 0; i < cnt; ++i)
    print(stored[i]);
  split("", stored);
  cnt = 0;
}

"generic" == state && $0 ~ /^Content-[Tt]ype: text\/html/ {
  stored[cnt++] = $0;
  state = "find-charset";
  next;
}

"find-charset" == state && $0 ~ /^Content-[Tt]ype:/ {
  flush_stored();
  state = "generic";
}

"find-charset" == state && $0 ~ /^<(META|meta).*charset=.*>$/ {
  match($0, /charset=([a-z|A-Z|0-9|-]*)/, a);
  match(stored[0], /charset=([a-z|A-Z|0-9|-]*)/, b);
  sub(b[1], a[1], stored[0]);

  flush_stored();
  state = "generic";
}

"find-charset" == state {
  stored[cnt++] = $0;
}

"generic" == state
